searchData={"items":[{"type":"module","title":"FLHook","doc":"[FLHook](https://github.com/DiscoveryGC/FLHook) is a community-managed tool\nfor managing\n[Freelancer](https://en.wikipedia.org/wiki/Freelancer_(video_game)) game\nservers. Freelancer is a pretty old game that has been released in 2003 by\nMicrosoft, but it still has a very committed community.\n\nFLHook allows connecting via a socket to run commands on and receive events\nfrom a Freelancer Server. This library provides an Elixir client for that\nmatter. You could use it to build web-based management interfaces or ingame\nchat bots, for example.","ref":"FLHook.html"},{"type":"module","title":"Connect to Server - FLHook","doc":"{:ok, client} = FLHook.Client.start_link(\n      host: \"myserver.com\",\n      password: \"s3cret\",\n    )\n\nAlternatively, create your own module that you can configure in your\napplication.\n\n    defmodule MyFLClient do\n      use FLHook.Client\n    end\n\nAdd the client to your supervision tree:\n\n    defmodule MyApp.Application do\n      use Application\n\n      def start(_type, _args) do\n        Supervisor.start_link(\n          [MyFLClient],\n          strategy: :one_for_one,\n          name: MyApp.Supervisor\n        )\n      end\n    end\n\nIn your config:\n\n    import Config\n\n    config :my_app, MyFLClient,\n      host: \"localhost\",\n      port: 1920,\n      event_mode: true,\n      connect_on_start: true,\n      backoff_interval: 1000,\n      connect_timeout: 5000,\n      password: \"s3cret\",\n      recv_timeout: 5000,\n      send_timeout: 5000","ref":"FLHook.html#module-connect-to-server"},{"type":"module","title":"Dispatch Command - FLHook","doc":"Send a command to the server and receive the result immediately:\n\n    {:ok, result} = FLHook.cmd(client, {\"addcash\", [\"MyUsername\", 10]})\n    new_cash = FLHook.Result.param!(result, \"cash\")\n    IO.puts(\"New cash: #{new_cash} credits\")","ref":"FLHook.html#module-dispatch-command"},{"type":"module","title":"Listen to Events - FLHook","doc":"Let the current process receive FLHook events:\n\n    FLHook.subscribe(client)\n\n    receive do\n      %FLHook.Event{type: \"kill\", dict: dict} ->\n        IO.inspect(dict, label: \"player killed\")\n    end","ref":"FLHook.html#module-listen-to-events"},{"type":"function","title":"FLHook.cmd/2","doc":"Sends a command to the socket and returns the result.","ref":"FLHook.html#cmd/2"},{"type":"function","title":"FLHook.cmd!/2","doc":"Sends a command to the socket and returns the result. Raises on error.","ref":"FLHook.html#cmd!/2"},{"type":"function","title":"FLHook.subscribe/2","doc":"Registers the specified process as event listener.","ref":"FLHook.html#subscribe/2"},{"type":"function","title":"FLHook.unsubscribe/2","doc":"Removes the event listener for the specified process.","ref":"FLHook.html#unsubscribe/2"},{"type":"module","title":"FLHook.Client","doc":"A client to connect to a FLHook socket.","ref":"FLHook.Client.html"},{"type":"function","title":"FLHook.Client.child_spec/1","doc":"The child specification for a FLHook client.","ref":"FLHook.Client.html#child_spec/1"},{"type":"function","title":"FLHook.Client.close/1","doc":"Closes the connection.","ref":"FLHook.Client.html#close/1"},{"type":"function","title":"FLHook.Client.connected?/1","doc":"Indicates whether the socket is connected.","ref":"FLHook.Client.html#connected?/1"},{"type":"function","title":"FLHook.Client.open/1","doc":"Opens the connection.","ref":"FLHook.Client.html#open/1"},{"type":"function","title":"FLHook.Client.start_link/1","doc":"Starts the FLHook client using the given config or options.","ref":"FLHook.Client.html#start_link/1"},{"type":"function","title":"FLHook.Client.start_link/2","doc":"Starts the FLHook client using the given config and options.","ref":"FLHook.Client.html#start_link/2"},{"type":"type","title":"FLHook.Client.client/0","doc":"Type representing a FLHook client process.","ref":"FLHook.Client.html#t:client/0"},{"type":"module","title":"FLHook.Config","doc":"A struct containing configuration for a client.","ref":"FLHook.Config.html"},{"type":"type","title":"FLHook.Config.t/0","doc":"","ref":"FLHook.Config.html#t:t/0"},{"type":"protocol","title":"FLHook.Command","doc":"A protocol to implement custom commands.","ref":"FLHook.Command.html"},{"type":"function","title":"FLHook.Command.to_cmd/1","doc":"Returns a command string or tuple. It may even return another command except\nitself.","ref":"FLHook.Command.html#to_cmd/1"},{"type":"type","title":"FLHook.Command.command/0","doc":"Type representing a command.","ref":"FLHook.Command.html#t:command/0"},{"type":"type","title":"FLHook.Command.serializable/0","doc":"","ref":"FLHook.Command.html#t:serializable/0"},{"type":"type","title":"FLHook.Command.t/0","doc":"All the types that implement this protocol.","ref":"FLHook.Command.html#t:t/0"},{"type":"module","title":"FLHook.Dict","doc":"A module that provides helpers to decode command response and event data.","ref":"FLHook.Dict.html"},{"type":"function","title":"FLHook.Dict.fetch/3","doc":"Fetches the field using the specified key from the dict. Optionally allows\nspecification of a type to coerce the param to.","ref":"FLHook.Dict.html#fetch/3"},{"type":"function","title":"FLHook.Dict.fetch!/3","doc":"Fetches the field using the specified key from the dict. Optionally allows\nspecification of a type to coerce the value to. Raises when the param is\nmissing or could not be coerced to the given type.","ref":"FLHook.Dict.html#fetch!/3"},{"type":"function","title":"FLHook.Dict.get/4","doc":"Gets the field using the specified key from the dict.","ref":"FLHook.Dict.html#get/4"},{"type":"function","title":"FLHook.Dict.pick/2","doc":"Fetches multiple fields with the specified keys from the dict. Optionally\nallows specification of a type to coerce the param to.","ref":"FLHook.Dict.html#pick/2"},{"type":"function","title":"FLHook.Dict.pick_into/3","doc":"Puts multiple fields using the specified keys from the dict into the given\nstruct. Optionally allows specification of a type to coerce the param to.","ref":"FLHook.Dict.html#pick_into/3"},{"type":"function","title":"FLHook.Dict.to_map/2","doc":"Converts the dict to a plain map.","ref":"FLHook.Dict.html#to_map/2"},{"type":"type","title":"FLHook.Dict.data/0","doc":"","ref":"FLHook.Dict.html#t:data/0"},{"type":"type","title":"FLHook.Dict.field_type/0","doc":"","ref":"FLHook.Dict.html#t:field_type/0"},{"type":"type","title":"FLHook.Dict.key/0","doc":"","ref":"FLHook.Dict.html#t:key/0"},{"type":"type","title":"FLHook.Dict.t/0","doc":"","ref":"FLHook.Dict.html#t:t/0"},{"type":"module","title":"FLHook.Duration","doc":"A struct that represents a duration.","ref":"FLHook.Duration.html"},{"type":"type","title":"FLHook.Duration.t/0","doc":"","ref":"FLHook.Duration.html#t:t/0"},{"type":"module","title":"FLHook.Event","doc":"An event that is sent by the client in event mode when something happens on\nthe server.","ref":"FLHook.Event.html"},{"type":"type","title":"FLHook.Event.t/0","doc":"","ref":"FLHook.Event.html#t:t/0"},{"type":"behaviour","title":"FLHook.FieldType","doc":"A behaviour that can be implemented by custom field types.","ref":"FLHook.FieldType.html"},{"type":"callback","title":"FLHook.FieldType.parse/1","doc":"","ref":"FLHook.FieldType.html#c:parse/1"},{"type":"module","title":"FLHook.Result","doc":"A struct that contains result data and provides helpers to decode the\ncontained data.","ref":"FLHook.Result.html"},{"type":"function","title":"FLHook.Result.all/1","doc":"Converts a multiline result to a list of dictionaries.","ref":"FLHook.Result.html#all/1"},{"type":"function","title":"FLHook.Result.file!/1","doc":"Converts the result to a file string. Raises when the result is no file.","ref":"FLHook.Result.html#file!/1"},{"type":"function","title":"FLHook.Result.file_stream!/1","doc":"Converts the result to a file stream. Raises when the result is no file.","ref":"FLHook.Result.html#file_stream!/1"},{"type":"function","title":"FLHook.Result.one/1","doc":"Converts a result to dictionary. When the result has multiple lines only the\nfirst one is being returned. When first line is no valid dictionary, an empty\ndictionary is returned.","ref":"FLHook.Result.html#one/1"},{"type":"function","title":"FLHook.Result.raw/1","doc":"Gets the raw result string.","ref":"FLHook.Result.html#raw/1"},{"type":"function","title":"FLHook.Result.to_string/1","doc":"Converts the result to a string.","ref":"FLHook.Result.html#to_string/1"},{"type":"type","title":"FLHook.Result.t/0","doc":"","ref":"FLHook.Result.html#t:t/0"},{"type":"module","title":"FLHook.Codec","doc":"A module that is responsible for decoding and encoding data streams from and\nto the FLHook socket.","ref":"FLHook.Codec.html"},{"type":"function","title":"FLHook.Codec.decode/2","doc":"Decodes binary data from the socket using the specified codec.","ref":"FLHook.Codec.html#decode/2"},{"type":"function","title":"FLHook.Codec.encode/2","doc":"Encodes strings that will be sent to the socket using the specified codec.","ref":"FLHook.Codec.html#encode/2"},{"type":"type","title":"FLHook.Codec.codec/0","doc":"Type describing the supported codecs.","ref":"FLHook.Codec.html#t:codec/0"},{"type":"module","title":"FLHook.XMLText","doc":"The XML text module allows composing formatted text to be sent via a chat\ncommand.\n\nA full reference can be found here:\nhttps://docs.flhook.org/md_docs__usage__x_m_l__text__reference.html","ref":"FLHook.XMLText.html"},{"type":"function","title":"FLHook.XMLText.align/2","doc":"Adds an alignment node to the specified XML text struct.","ref":"FLHook.XMLText.html#align/2"},{"type":"function","title":"FLHook.XMLText.format/3","doc":"Adds a format node the specified XML text struct. You can specify a color and\noptional format flags.","ref":"FLHook.XMLText.html#format/3"},{"type":"function","title":"FLHook.XMLText.new/1","doc":"Creates a new XML text struct with the specified content.","ref":"FLHook.XMLText.html#new/1"},{"type":"function","title":"FLHook.XMLText.paragraph/1","doc":"Adds a paragraph node to the specified XML text struct.","ref":"FLHook.XMLText.html#paragraph/1"},{"type":"function","title":"FLHook.XMLText.text/2","doc":"Adds a text node to the specified XML text struct.","ref":"FLHook.XMLText.html#text/2"},{"type":"function","title":"FLHook.XMLText.to_string/1","doc":"Converts the XML text struct to a string.","ref":"FLHook.XMLText.html#to_string/1"},{"type":"type","title":"FLHook.XMLText.align/0","doc":"","ref":"FLHook.XMLText.html#t:align/0"},{"type":"type","title":"FLHook.XMLText.color/0","doc":"","ref":"FLHook.XMLText.html#t:color/0"},{"type":"type","title":"FLHook.XMLText.flag/0","doc":"","ref":"FLHook.XMLText.html#t:flag/0"},{"type":"type","title":"FLHook.XMLText.t/0","doc":"","ref":"FLHook.XMLText.html#t:t/0"},{"type":"exception","title":"FLHook.CodecError","doc":"An error indicating that decoding or encoding did not work.","ref":"FLHook.CodecError.html"},{"type":"type","title":"FLHook.CodecError.t/0","doc":"","ref":"FLHook.CodecError.html#t:t/0"},{"type":"exception","title":"FLHook.CommandError","doc":"An error indicating a command returned unsuccessfully.","ref":"FLHook.CommandError.html"},{"type":"function","title":"FLHook.CommandError.message/1","doc":"","ref":"FLHook.CommandError.html#message/1"},{"type":"type","title":"FLHook.CommandError.t/0","doc":"","ref":"FLHook.CommandError.html#t:t/0"},{"type":"exception","title":"FLHook.ConfigError","doc":"An error that indicates that configuration of the client is invalid.","ref":"FLHook.ConfigError.html"},{"type":"exception","title":"FLHook.FieldError","doc":"An error indicating an invalid or missing param.","ref":"FLHook.FieldError.html"},{"type":"function","title":"FLHook.FieldError.message/1","doc":"","ref":"FLHook.FieldError.html#message/1"},{"type":"type","title":"FLHook.FieldError.t/0","doc":"","ref":"FLHook.FieldError.html#t:t/0"},{"type":"exception","title":"FLHook.HandshakeError","doc":"An error that indicates that the socket connection is not a valid FLHook\nsocket or the encoding is wrong.","ref":"FLHook.HandshakeError.html"},{"type":"function","title":"FLHook.HandshakeError.message/1","doc":"","ref":"FLHook.HandshakeError.html#message/1"},{"type":"exception","title":"FLHook.SocketError","doc":"An error that indicates that the socket connection has a problem.","ref":"FLHook.SocketError.html"},{"type":"function","title":"FLHook.SocketError.message/1","doc":"","ref":"FLHook.SocketError.html#message/1"},{"type":"type","title":"FLHook.SocketError.t/0","doc":"","ref":"FLHook.SocketError.html#t:t/0"},{"type":"extras","title":"License","doc":"MIT License\n\nCopyright (c) 2020 Tobias Casper\n\nPermission is hereby granted, free of charge, to any person obtaining a copy\nof this software and associated documentation files (the \"Software\"), to deal\nin the Software without restriction, including without limitation the rights\nto use, copy, modify, merge, publish, distribute, sublicense, and/or sell\ncopies of the Software, and to permit persons to whom the Software is\nfurnished to do so, subject to the following conditions:\n\nThe above copyright notice and this permission notice shall be included in all\ncopies or substantial portions of the Software.\n\nTHE SOFTWARE IS PROVIDED \"AS IS\", WITHOUT WARRANTY OF ANY KIND, EXPRESS OR\nIMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY,\nFITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT. IN NO EVENT SHALL THE\nAUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER\nLIABILITY, WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING FROM,\nOUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER DEALINGS IN THE\nSOFTWARE.","ref":"license.html"},{"type":"extras","title":"Readme","doc":"# FLHook Client\n\n[![Build](https://github.com/tlux/fl_hook_client/actions/workflows/elixir.yml/badge.svg)](https://github.com/tlux/fl_hook_client/actions/workflows/elixir.yml)\n[![Coverage Status](https://coveralls.io/repos/github/tlux/fl_hook_client/badge.svg?branch=main)](https://coveralls.io/github/tlux/fl_hook_client?branch=main)\n[![Module Version](https://img.shields.io/hexpm/v/fl_hook_client.svg)](https://hex.pm/packages/fl_hook_client)\n[![Hex Docs](https://img.shields.io/badge/hex-docs-lightgreen.svg)](https://hexdocs.pm/fl_hook_client/)\n[![License](https://img.shields.io/hexpm/l/fl_hook_client.svg)](https://github.com/tlux/fl_hook_client/blob/main/LICENSE.md)\n[![Last Updated](https://img.shields.io/github/last-commit/tlux/fl_hook_client.svg)](https://github.com/tlux/fl_hook_client/commits/main)\n\n[FLHook](https://github.com/DiscoveryGC/FLHook) is a community-managed tool for\nmanaging [Freelancer]( )\ngame servers. Freelancer is a pretty old game that has been released in 2003 by\nMicrosoft, but it still has a very committed community.\n\nFLHook allows connecting via a socket to run commands on and receive events from\na Freelancer Server. This library provides an Elixir client for that matter. You\ncould use it to build web-based management interfaces or ingame chat bots, for\nexample.","ref":"readme.html"},{"type":"extras","title":"Use Cases - Readme","doc":"- Chat Bots\n- Web-based Services\n  - Character Management\n  - Character Money Deposit\n  - Character Cargo Deposit\n- Player Tracking and Travel Journal\n- Custom Cargo Missions","ref":"readme.html#use-cases"},{"type":"extras","title":"Installation - Readme","doc":"The package is [available in Hex](https://hex.pm/packages/fl_hook_client) and\ncan be installed by adding `fl_hook_client` to your list of dependencies in\n`mix.exs`:\n\n```elixir\ndef deps do\n  [\n    {:fl_hook_client, \"~> 2.1\"}\n  ]\nend\n```","ref":"readme.html#installation"},{"type":"extras","title":"Usage - Readme","doc":"Initiate a connection to a server (with a list of all possible options):\n\n```elixir\n{:ok, client} =\n  FLHook.Client.start_link(\n    backoff_interval: 1234,\n    codec: :unicode,\n    connect_timeout: 2345,\n    event_mode: true,\n    host: \"localhost\",\n    inet_adapter: :inet,\n    name: CustomFLHookClient,\n    password: \"$3cret\",\n    port: 1920,\n    recv_timeout: 3456,\n    send_timeout: 4567,\n    tcp_adapter: :gen_tcp\n  )\n```\n\nOnce connected, you can send commands to the server.\n\n```elixir\nFLHook.cmd(client, \"readcharfile Player1\")\n# => {:ok, %FLHook.Result{lines: [\"...\", \"...\"]}}\n```\n\nAlternatively, you can use the tuple format for commands:\n\n```elixir\nFLHook.cmd(client, {\"readcharfile\", [\"Player1\"]})\n```\n\nAdditionally, any value is accepted as command argument that implements the\n`FLHook.Command` protocol.\n\nBy default, also events from the server will be sent to all subscribed\nprocesses. You can add a listener for the current process as follows:\n\n```elixir\nFLHook.subscribe(client)\n```\n\nYou can also register other processes as listeners:\n\n```elixir\npid = self()\n\nTask.async(fn ->\n  FLHook.subscribe(client, pid)\nend)\n```\n\nUnsubscription works the same way.\n\nThe received events have the following format:\n\n```elixir\niex> flush()\n%FLHook.Event{\n  type: \"launch\",\n  dict: %FLHook.Dict{data: \"system\" => \"Li01\", \"char\" => \"Player\"}\n}\n```\n\nGenerally, it is recommended to start the client as part of your supervision\ntree. To do this, add a custom module using the `FLHook.Client` module.\n\n```elixir\ndefmodule MyApp.FLClient do\n  use FLHook.Client, otp_app: :my_app\nend\n```\n\nThen, add some configuration in config.exs or your environment-specific configs.\n\n```elixir\nconfig :my_app, MyApp.FLClient,\n  host: \"localhost\",\n  port: 1920\n```\n\nAfter that, add your custom client to your application.ex.\n\n```elixir\ndef start(_type, _args) do\n  children = [\n    MyApp.FLClient\n  ]\n\n  # ...\nend\n```\n\nVoilà! You can now send commands to the same server without passing the client\nprocess as first argument.\n\n```elixir\nMyApp.FLClient.cmd(client, \"readcharfile Player1\")\n# => {:ok, %FLHook.Result{lines: [\"...\", \"...\"]}}\n```","ref":"readme.html#usage"},{"type":"extras","title":"Docs - Readme","doc":"Documentation can be generated with\n[ExDoc](https://github.com/elixir-lang/ex_doc) and is published on\n[HexDocs](https://hexdocs.pm/fl_hook_client).","ref":"readme.html#docs"}],"content_type":"text/markdown"}